//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Tue Feb  5 10:04:52 2019
// Version: v12.0 12.500.0.22
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// video_isp_pipe
module video_isp_pipe(
    // Inputs
    Data_In_Vld_i,
    Data_In_i,
    RESET_n_I,
    SEL_i,
    SYS_CLK_I,
    display_frame_done_i,
    dma_read_ack_i,
    dma_read_done_i,
    frame_height_i,
    frame_width_i,
    fx_i,
    fy_i,
    global_alpha_i,
    image_height_i,
    image_valid_i,
    image_width_i,
    object_ddr_start_addr_i,
    object_read_start_i,
    sharpness_K,
    // Outputs
    Cb_Out_o,
    Cr_Out_o,
    Y_Out_o,
    alpha_blend_proc_compl_o,
    frame_one_line_done_o,
    object_bytes_to_read_o,
    object_read_req_o,
    object_start_read_addr_o,
    video_data_valid_out_o
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input         Data_In_Vld_i;
input  [7:0]  Data_In_i;
input         RESET_n_I;
input         SEL_i;
input         SYS_CLK_I;
input         display_frame_done_i;
input         dma_read_ack_i;
input         dma_read_done_i;
input  [10:0] frame_height_i;
input  [10:0] frame_width_i;
input  [10:0] fx_i;
input  [10:0] fy_i;
input  [7:0]  global_alpha_i;
input  [10:0] image_height_i;
input         image_valid_i;
input  [10:0] image_width_i;
input  [31:0] object_ddr_start_addr_i;
input         object_read_start_i;
input  [7:0]  sharpness_K;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output [7:0]  Cb_Out_o;
output [7:0]  Cr_Out_o;
output [7:0]  Y_Out_o;
output        alpha_blend_proc_compl_o;
output        frame_one_line_done_o;
output [15:0] object_bytes_to_read_o;
output        object_read_req_o;
output [31:0] object_start_read_addr_o;
output        video_data_valid_out_o;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire           alpha_blend_proc_compl_o_0;
wire   [7:0]   Alpha_Blending_Control_IP0_0_vout_o7to0;
wire   [15:8]  Alpha_Blending_Control_IP0_0_vout_o15to8;
wire   [23:16] Alpha_Blending_Control_IP0_0_vout_o23to16;
wire           Alpha_Blending_Control_IP0_0_vout_valid_o;
wire           Alpha_Blending_Control_IP0_0_write_image_next_line_o;
wire   [7:0]   Bayer_IP0_0_B_Out_o;
wire   [7:0]   Bayer_IP0_0_G_Out_o;
wire   [7:0]   Bayer_IP0_0_R_Out_o;
wire           Bayer_IP0_0_RGB_Vld_out_o;
wire   [7:0]   Cb_Out_o_net_0;
wire   [7:0]   Cr_Out_o_net_0;
wire   [7:0]   Data_In_i;
wire           Data_In_Vld_i;
wire           Delay_0_data_Vld_out_o;
wire   [7:0]   Delay_0_Y_Out_o7to0;
wire   [15:8]  Delay_0_Y_Out_o15to8;
wire   [23:16] Delay_0_Y_Out_o23to16;
wire           display_frame_done_i;
wire           dma_read_ack_i;
wire           dma_read_done_i;
wire   [10:0]  frame_height_i;
wire           frame_one_line_done_o_0;
wire   [10:0]  frame_width_i;
wire   [10:0]  fx_i;
wire   [10:0]  fy_i;
wire   [7:0]   global_alpha_i;
wire   [10:0]  image_height_i;
wire           image_valid_i;
wire   [10:0]  image_width_i;
wire           ImageEdgeDetection_IP0_0_data_Vld_out_o;
wire   [7:0]   ImageEdgeDetection_IP0_0_Y_Out_o;
wire   [7:0]   Mux2x1_0_DATA0_OUT_o;
wire   [7:0]   Mux2x1_0_DATA1_OUT_o;
wire   [7:0]   Mux2x1_0_DATA2_OUT_o;
wire           Mux2x1_0_DATAOut_VLD_o;
wire   [15:0]  object_bytes_to_read_o_net_0;
wire   [31:0]  object_ddr_start_addr_i;
wire           object_read_req_o_net_0;
wire           object_read_start_i;
wire   [31:0]  object_start_read_addr_o_net_0;
wire           RESET_n_I;
wire           RGB2YCbCr_IP0_0_data_enable_o;
wire   [7:0]   RGB2YCbCr_IP0_0_Y_out_o;
wire   [7:0]   RGB2YCbCr_IP1_0_Cb_out_o;
wire   [7:0]   RGB2YCbCr_IP1_0_Cr_out_o;
wire           RGB2YCbCr_IP1_0_data_enable_o;
wire   [7:0]   RGB2YCbCr_IP1_0_Y_out_o;
wire           SEL_i;
wire   [7:0]   sharpness_K;
wire           SYS_CLK_I;
wire           video_data_valid_out_o_0;
wire   [7:0]   Y_Out_o_net_0;
wire   [7:0]   YCbCr2RGB_IP0_0_Blue_out_o;
wire           YCbCr2RGB_IP0_0_data_enable_o;
wire   [7:0]   YCbCr2RGB_IP0_0_Green_out_o;
wire   [7:0]   YCbCr2RGB_IP0_0_Red_out_o;
wire           video_data_valid_out_o_0_net_0;
wire           alpha_blend_proc_compl_o_0_net_0;
wire           frame_one_line_done_o_0_net_0;
wire           object_read_req_o_net_1;
wire   [7:0]   Cr_Out_o_net_1;
wire   [7:0]   Y_Out_o_net_1;
wire   [7:0]   Cb_Out_o_net_1;
wire   [15:0]  object_bytes_to_read_o_net_1;
wire   [31:0]  object_start_read_addr_o_net_1;
wire   [23:0]  frame_data_i_net_0;
wire   [23:0]  vout_o_net_0;
wire   [23:0]  Y_in_i_net_0;
wire   [23:0]  Y_Out_o_net_2;
//--------------------------------------------------------------------
// TiedOff Nets
//--------------------------------------------------------------------
wire   [31:0]  image_data_i_const_net_0;
wire           GND_net;
wire   [7:0]   Cb_i_const_net_0;
wire   [7:0]   Cr_i_const_net_0;
//--------------------------------------------------------------------
// Constant assignments
//--------------------------------------------------------------------
assign image_data_i_const_net_0 = 32'h00000000;
assign GND_net                  = 1'b0;
assign Cb_i_const_net_0         = 8'h80;
assign Cr_i_const_net_0         = 8'h80;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign video_data_valid_out_o_0_net_0   = video_data_valid_out_o_0;
assign video_data_valid_out_o           = video_data_valid_out_o_0_net_0;
assign alpha_blend_proc_compl_o_0_net_0 = alpha_blend_proc_compl_o_0;
assign alpha_blend_proc_compl_o         = alpha_blend_proc_compl_o_0_net_0;
assign frame_one_line_done_o_0_net_0    = frame_one_line_done_o_0;
assign frame_one_line_done_o            = frame_one_line_done_o_0_net_0;
assign object_read_req_o_net_1          = object_read_req_o_net_0;
assign object_read_req_o                = object_read_req_o_net_1;
assign Cr_Out_o_net_1                   = Cr_Out_o_net_0;
assign Cr_Out_o[7:0]                    = Cr_Out_o_net_1;
assign Y_Out_o_net_1                    = Y_Out_o_net_0;
assign Y_Out_o[7:0]                     = Y_Out_o_net_1;
assign Cb_Out_o_net_1                   = Cb_Out_o_net_0;
assign Cb_Out_o[7:0]                    = Cb_Out_o_net_1;
assign object_bytes_to_read_o_net_1     = object_bytes_to_read_o_net_0;
assign object_bytes_to_read_o[15:0]     = object_bytes_to_read_o_net_1;
assign object_start_read_addr_o_net_1   = object_start_read_addr_o_net_0;
assign object_start_read_addr_o[31:0]   = object_start_read_addr_o_net_1;
//--------------------------------------------------------------------
// Slices assignments
//--------------------------------------------------------------------
assign Alpha_Blending_Control_IP0_0_vout_o7to0   = vout_o_net_0[7:0];
assign Alpha_Blending_Control_IP0_0_vout_o15to8  = vout_o_net_0[15:8];
assign Alpha_Blending_Control_IP0_0_vout_o23to16 = vout_o_net_0[23:16];
assign Delay_0_Y_Out_o7to0                       = Y_Out_o_net_2[7:0];
assign Delay_0_Y_Out_o15to8                      = Y_Out_o_net_2[15:8];
assign Delay_0_Y_Out_o23to16                     = Y_Out_o_net_2[23:16];
//--------------------------------------------------------------------
// Concatenation assignments
//--------------------------------------------------------------------
assign frame_data_i_net_0 = { Mux2x1_0_DATA0_OUT_o , Mux2x1_0_DATA1_OUT_o , Mux2x1_0_DATA2_OUT_o };
assign Y_in_i_net_0       = { Bayer_IP0_0_B_Out_o , Bayer_IP0_0_G_Out_o , Bayer_IP0_0_R_Out_o };
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------Alpha_Blending_Control_IP0
Alpha_Blending_Control_IP0 Alpha_Blending_Control_IP0_0(
        // Inputs
        .SYS_CLK_I                ( SYS_CLK_I ),
        .RESET_n_I                ( RESET_n_I ),
        .video_param_valid_i      ( object_read_start_i ),
        .image_valid_i            ( image_valid_i ),
        .frame_valid_i            ( Mux2x1_0_DATAOut_VLD_o ),
        .image_data_i             ( image_data_i_const_net_0 ),
        .frame_data_i             ( frame_data_i_net_0 ),
        .fx_i                     ( fx_i ),
        .fy_i                     ( fy_i ),
        .frame_width_i            ( frame_width_i ),
        .frame_height_i           ( frame_height_i ),
        .image_width_i            ( image_width_i ),
        .image_height_i           ( image_height_i ),
        .global_alpha_i           ( global_alpha_i ),
        // Outputs
        .vout_valid_o             ( Alpha_Blending_Control_IP0_0_vout_valid_o ),
        .write_image_next_line_o  ( Alpha_Blending_Control_IP0_0_write_image_next_line_o ),
        .frame_one_line_done_o    ( frame_one_line_done_o_0 ),
        .alpha_blend_proc_compl_o ( alpha_blend_proc_compl_o_0 ),
        .vout_o                   ( vout_o_net_0 ) 
        );

//--------alpha_object_read
alpha_object_read alpha_object_read_0(
        // Inputs
        .SYS_CLK_I               ( SYS_CLK_I ),
        .RESET_n_I               ( RESET_n_I ),
        .start_i                 ( object_read_start_i ),
        .next_object_line_read_i ( Alpha_Blending_Control_IP0_0_write_image_next_line_o ),
        .frame_done_i            ( display_frame_done_i ),
        .read_ack_i              ( dma_read_ack_i ),
        .read_done_i             ( dma_read_done_i ),
        .object_ddr_start_addr_i ( object_ddr_start_addr_i ),
        .obj_w_i                 ( image_width_i ),
        .obj_h_i                 ( image_height_i ),
        // Outputs
        .read_req_o              ( object_read_req_o_net_0 ),
        .start_read_addr_o       ( object_start_read_addr_o_net_0 ),
        .bytes_to_read_o         ( object_bytes_to_read_o_net_0 ) 
        );

//--------Bayer_IP0
Bayer_IP0 Bayer_IP0_0(
        // Inputs
        .SYS_CLK_I     ( SYS_CLK_I ),
        .RESET_n_I     ( RESET_n_I ),
        .Data_In_Vld_i ( Data_In_Vld_i ),
        .Data_In_i     ( Data_In_i ),
        // Outputs
        .RGB_Vld_out_o ( Bayer_IP0_0_RGB_Vld_out_o ),
        .R_Out_o       ( Bayer_IP0_0_R_Out_o ),
        .G_Out_o       ( Bayer_IP0_0_G_Out_o ),
        .B_Out_o       ( Bayer_IP0_0_B_Out_o ) 
        );

//--------Delay
Delay Delay_0(
        // Inputs
        .SYS_CLK_I      ( SYS_CLK_I ),
        .RESET_n_I      ( RESET_n_I ),
        .Data_In_Vld_i  ( Bayer_IP0_0_RGB_Vld_out_o ),
        .Y_in_i         ( Y_in_i_net_0 ),
        // Outputs
        .data_Vld_out_o ( Delay_0_data_Vld_out_o ),
        .Y_Out_o        ( Y_Out_o_net_2 ) 
        );

//--------ImageEdgeDetection_IP0
ImageEdgeDetection_IP0 ImageEdgeDetection_IP0_0(
        // Inputs
        .SYS_CLK_I      ( SYS_CLK_I ),
        .RESET_n_I      ( RESET_n_I ),
        .Data_In_Vld_i  ( RGB2YCbCr_IP0_0_data_enable_o ),
        .Y_in_i         ( RGB2YCbCr_IP0_0_Y_out_o ),
        // Outputs
        .data_Vld_out_o ( ImageEdgeDetection_IP0_0_data_Vld_out_o ),
        .Y_Out_o        ( ImageEdgeDetection_IP0_0_Y_Out_o ) 
        );

//--------ImageSharpenFilter_IP0
ImageSharpenFilter_IP0 ImageSharpenFilter_IP0_0(
        // Inputs
        .SYS_CLK_I      ( SYS_CLK_I ),
        .RESET_n_I      ( RESET_n_I ),
        .Data_In_Vld_i  ( RGB2YCbCr_IP1_0_data_enable_o ),
        .Y_in_i         ( RGB2YCbCr_IP1_0_Y_out_o ),
        .Cb_in_i        ( RGB2YCbCr_IP1_0_Cb_out_o ),
        .Cr_in_i        ( RGB2YCbCr_IP1_0_Cr_out_o ),
        .sharpness_K    ( sharpness_K ),
        // Outputs
        .data_Vld_out_o ( video_data_valid_out_o_0 ),
        .Y_Out_o        ( Y_Out_o_net_0 ),
        .Cb_Out_o       ( Cb_Out_o_net_0 ),
        .Cr_Out_o       ( Cr_Out_o_net_0 ) 
        );

//--------Mux2x1
Mux2x1 Mux2x1_0(
        // Inputs
        .SYS_CLK_I     ( SYS_CLK_I ),
        .nRESET_I      ( RESET_n_I ),
        .DATAIn0_VLD_i ( Delay_0_data_Vld_out_o ),
        .DATAIn1_VLD_i ( YCbCr2RGB_IP0_0_data_enable_o ),
        .SEL_i         ( SEL_i ),
        .DATA00_In_i   ( Delay_0_Y_Out_o23to16 ),
        .DATA01_In_i   ( Delay_0_Y_Out_o15to8 ),
        .DATA02_In_i   ( Delay_0_Y_Out_o7to0 ),
        .DATA10_In_i   ( YCbCr2RGB_IP0_0_Red_out_o ),
        .DATA11_In_i   ( YCbCr2RGB_IP0_0_Green_out_o ),
        .DATA12_In_i   ( YCbCr2RGB_IP0_0_Blue_out_o ),
        // Outputs
        .DATAOut_VLD_o ( Mux2x1_0_DATAOut_VLD_o ),
        .DATA0_OUT_o   ( Mux2x1_0_DATA0_OUT_o ),
        .DATA1_OUT_o   ( Mux2x1_0_DATA1_OUT_o ),
        .DATA2_OUT_o   ( Mux2x1_0_DATA2_OUT_o ) 
        );

//--------RGB2YCbCr_IP0
RGB2YCbCr_IP0 RGB2YCbCr_IP0_0(
        // Inputs
        .CLOCK_I       ( SYS_CLK_I ),
        .RESET_N_I     ( RESET_n_I ),
        .data_enable_i ( Bayer_IP0_0_RGB_Vld_out_o ),
        .horz_sync_i   ( GND_net ),
        .vert_sync_i   ( GND_net ),
        .hactive_i     ( GND_net ),
        .vactive_i     ( GND_net ),
        .Red_i         ( Bayer_IP0_0_R_Out_o ),
        .Green_i       ( Bayer_IP0_0_G_Out_o ),
        .Blue_i        ( Bayer_IP0_0_B_Out_o ),
        // Outputs
        .data_enable_o ( RGB2YCbCr_IP0_0_data_enable_o ),
        .horz_sync_o   (  ),
        .vert_sync_o   (  ),
        .hactive_o     (  ),
        .vactive_o     (  ),
        .Y_out_o       ( RGB2YCbCr_IP0_0_Y_out_o ),
        .Cb_out_o      (  ),
        .Cr_out_o      (  ) 
        );

//--------RGB2YCbCr_IP1
RGB2YCbCr_IP1 RGB2YCbCr_IP1_0(
        // Inputs
        .CLOCK_I       ( SYS_CLK_I ),
        .RESET_N_I     ( RESET_n_I ),
        .data_enable_i ( Alpha_Blending_Control_IP0_0_vout_valid_o ),
        .horz_sync_i   ( GND_net ),
        .vert_sync_i   ( GND_net ),
        .hactive_i     ( GND_net ),
        .vactive_i     ( GND_net ),
        .Red_i         ( Alpha_Blending_Control_IP0_0_vout_o23to16 ),
        .Green_i       ( Alpha_Blending_Control_IP0_0_vout_o15to8 ),
        .Blue_i        ( Alpha_Blending_Control_IP0_0_vout_o7to0 ),
        // Outputs
        .data_enable_o ( RGB2YCbCr_IP1_0_data_enable_o ),
        .horz_sync_o   (  ),
        .vert_sync_o   (  ),
        .hactive_o     (  ),
        .vactive_o     (  ),
        .Y_out_o       ( RGB2YCbCr_IP1_0_Y_out_o ),
        .Cb_out_o      ( RGB2YCbCr_IP1_0_Cb_out_o ),
        .Cr_out_o      ( RGB2YCbCr_IP1_0_Cr_out_o ) 
        );

//--------YCbCr2RGB_IP0
YCbCr2RGB_IP0 YCbCr2RGB_IP0_0(
        // Inputs
        .CLOCK_I       ( SYS_CLK_I ),
        .RESET_N_I     ( RESET_n_I ),
        .data_enable_i ( ImageEdgeDetection_IP0_0_data_Vld_out_o ),
        .horz_sync_i   ( GND_net ),
        .vert_sync_i   ( GND_net ),
        .hactive_i     ( GND_net ),
        .vactive_i     ( GND_net ),
        .Y_i           ( ImageEdgeDetection_IP0_0_Y_Out_o ),
        .Cb_i          ( Cb_i_const_net_0 ),
        .Cr_i          ( Cr_i_const_net_0 ),
        // Outputs
        .data_enable_o ( YCbCr2RGB_IP0_0_data_enable_o ),
        .horz_sync_o   (  ),
        .vert_sync_o   (  ),
        .hactive_o     (  ),
        .vactive_o     (  ),
        .Red_out_o     ( YCbCr2RGB_IP0_0_Red_out_o ),
        .Green_out_o   ( YCbCr2RGB_IP0_0_Green_out_o ),
        .Blue_out_o    ( YCbCr2RGB_IP0_0_Blue_out_o ) 
        );


endmodule
